require 'gem_2345/import-once'
module Sass
  class Engine
    def self.new(*args)
      instance = super
      instance.extend(Gem2345::ImportOnce::Engine)
      if i = instance.options[:importer]
        i.extend(Gem2345::ImportOnce::Importer) unless i.is_a?(Gem2345::ImportOnce::Importer)
      end
      instance.options[:load_paths].each do |path|
        if path.is_a?(Sass::Importers::Base) && !path.is_a?(Gem2345::ImportOnce::Importer)
          path.extend(Gem2345::ImportOnce::Importer)
        elsif !path.is_a?(Sass::Importers::Base)
          Sass::Util.sass_warn "WARNING: #{path.inspect} is on the load path and is not an importer."
        end
      end
      instance
    end
  end
end
